import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import { RestCollectionViewExt } from "./rest-collection-view-ext";
import { CollectionViewNavigator } from '@mescius/wijmo.input';
import { createElement } from '@mescius/wijmo';
import { FlexGrid } from '@mescius/wijmo.grid';
import { FlexGridFilter } from '@mescius/wijmo.grid.filter';
// field info for PurchaseOrders table
const fields = 'OrderId,StockItem,Color,State,City,Quantity,UnitPrice,Date,IsChillerStock'.split(',');
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
// initialize PageSize
const pageSize = 100;
// create the grid to show the data
let theGrid = new FlexGrid('#theGrid', {
isReadOnly: true,
// create RestCollectionViewExt
itemsSource: new RestCollectionViewExt('purchaseorders', {
fields: fields,
pageSize: pageSize,
loading: () => { toggleSpinner(theGrid, true); },
loaded: () => { toggleSpinner(theGrid, false); }
})
});
// add the filter
new FlexGridFilter(theGrid);
// add the navigator
let nav = new CollectionViewNavigator('#theNavigator', {
cv: theGrid.collectionView,
byPage: true
});
// toggle b/w pagination and virtualization
document.body.addEventListener('click', e => {
let radio = e.target, view = theGrid.collectionView;
if (radio.name == "viewtype" && radio.id === 'paging') {
view.virtualization = false;
view.pageSize = pageSize;
nav.hostElement.style.display = 'inline-flex';
}
if (radio.name == "viewtype" && radio.id !== 'paging') {
let view = theGrid.collectionView;
view.virtualization = true;
view.pageSize = 0;
nav.hostElement.style.display = 'none';
}
});
}
//show gif loader while data loading
function toggleSpinner(grid, show) {
let _rect = grid.controlRect;
let elem = grid.hostElement.querySelector('.spinner');
if (!elem)
elem = createElement(`<div class='spinner' style="left:${_rect.left}px;top:${_rect.top}px;width:${_rect.width}px;height:${_rect.height}px;"><img src="resources/Rounded%20blocks.gif"></div>`, grid.hostElement);
elem.style.display = show ? 'block' : 'none';
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView RestAPI</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js"
integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA=="
crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<label>
<input id="paging" name="viewtype" type="radio" value="paging" checked />Paging
</label>
<label>
<input id="virtualization" type="radio" name="viewtype" value="Virtualization" />Virtualization
</label>
<br />
<div id="theNavigator"></div>
<div id="theGrid"></div>
<p id="msg"></p>
</div>
</body>
</html>
body {
margin-bottom: 36pt;
margin-top: 10px;
}
label {
padding-right: 10px;
}
.wj-flexgrid {
height: 400px;
}
.spinner {
position: absolute;
z-index: 10;
opacity: .5;
}
.spinner img {
margin: auto;
position: relative;
top: 40%;
left: 45%;
}
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
return new (P || (P = Promise))(function (resolve, reject) {
function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
step((generator = generator.apply(thisArg, _arguments || [])).next());
});
};
import { RestCollectionView } from '@mescius/wijmo.rest';
import { DataType, isDate, DateTime, asNumber, isBoolean, httpRequest, copy, changeType, isString } from '@mescius/wijmo';
const _apiUrl = "https://demodata.mescius.io/wwi/api/v1/";
/**
* Class that extends {@link RestCollectionView} to support RestAPI data sources.
*/
export class RestCollectionViewExt extends RestCollectionView {
/**
* Initializes a new instance of the {@link RestCollectionViewExt} class.
*
* @param tableName Name of the table (entity) to retrieve from the service.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link RestCollectionView}.
*/
constructor(tableName, options) {
super();
this._url = _apiUrl;
this._tbl = tableName;
copy(this, options);
}
// parse json data
_jsonReviver(key, value) {
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// get parameter for sorting, filtering, paging and virtualization
_getReadParams() {
let settings = {};
// apply filter
if (this.filterOnServer && this._filterProvider) {
let filter = this._asODataFilter(this._filterProvider);
if (filter.length > 0) {
settings.filterBy = filter;
}
}
//apply sortBy
if (this.sortOnServer && this.sortDescriptions.length > 0) {
let _sortBy = [];
for (let i = 0; i < this.sortDescriptions.length; i++) {
let sort = `${this.sortDescriptions[i].property} ${this.sortDescriptions[i].ascending ? 'ASC' : 'DESC'}`;
_sortBy.push(sort); // add sort
}
settings.sortBy = _sortBy.join(',');
}
// current view window
if (this.virtualization) {
settings.skip = this._start;
settings.top = this._fetchSize();
}
// get page params
if (this.pageOnServer && this.pageSize > 0) {
settings.skip = this.pageIndex * this.pageSize;
settings.top = this.pageSize;
}
if (this.fields && this.fields.length > 0) {
settings.select = this.fields;
}
return settings;
}
// ** overrides
getItems() {
// cancel any pending requests
if (this._pendingReq) {
this._pendingReq.abort();
}
return new Promise(resolve => {
let _settings = this._getReadParams(); // get the items virtually
this._pendingReq = httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.items);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => { this._pendingReq = null; } // no pending requests
});
});
;
}
//#region Filter Implementation
// gets the OData filter definition from a wijmo.grid.filter.FlexGridFilter object.
// https://www.odata.org/documentation/odata-version-2-0/uri-conventions/
_asODataFilter(filter) {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c], cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
}
else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf) {
let col = vf.column, fld = col.binding, map = col.dataMap, def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, DataType.String, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def)
def += ' or ';
def += this._asEquals(fld, value, DataType.String);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld, value, type) {
let def = '', DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
}
else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
}
else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf) {
let c1 = this._asODataCondition(cf, cf.condition1), c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2)
return '((' + c1 + (cf.and ? ') and (' : ') or (') + c2 + '))';
if (c1)
return '(' + c1 + ')';
if (c2)
return '(' + c2 + ')';
return null;
}
_asODataCondition(cf, cnd) {
let col = cf.column, fld = col.binding, map = col.dataMap, value = changeType(cnd.value, DataType.String, col.format);
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, DataType.String);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return `${fld} starts-with ${value}`;
case 7: // EW = 7,
return `${fld} ends-with ${value}`;
case 8: // CT = 8,
return `${fld} contains ${value}`;
case 9: // NC = 9
return `${fld} not-contains ${value}`;
case 10: // NBW = 10
return `${fld} not-starts-with ${value}`;
case 11: // NEW = 11
return `${fld} not-ends-with ${value}`;
}
}
_asODataValue(value, dataType) {
if (isDate(value)) {
value = `'${value.toJSON()}'`;
return value;
}
else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
}
else if (isBoolean(value)) {
return "'" + value + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/latest/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<div class="container-fluid">
<label>
<input id="paging" type="radio" name="viewtype" value="paging" checked
@change="toggleFeature('paging')" />Paging
</label>
<label>
<input id="virtualization" type="radio" name="viewtype" value="virtualization"
@change="toggleFeature('virtualization')" />Virtualization
</label>
<br />
<wj-collection-view-navigator v-if="enablePaging" ref="navRef" :cv="view" :by-page="true" />
<wj-flex-grid :initialized="flexInitialized" :is-read-only="isReadOnly" :items-source="view">
<wj-flex-grid-filter />
</wj-flex-grid>
</div>
</template>
<script setup>
import { RestCollectionViewExt } from "./rest-collection-view-ext";
import { ref } from "vue";
//
// field info for PurchaseOrders table
const fields = 'OrderId,StockItem,Color,State,City,Quantity,UnitPrice,Date,IsChillerStock'.split(',');
const enablePaging = ref(true);
const isReadOnly = ref(true);
const settings = {
fields: fields,
pageSize: 100,
loading: () => {
toggleSpinner(flexGrid.value, true);
},
loaded: () => {
toggleSpinner(flexGrid.value, false);
},
};
const view = ref(null);
const flexGrid = ref(null);
//create RestCollectionViewExt instance
view.value = new RestCollectionViewExt('purchaseorders', settings);
function flexInitialized(grid) {
flexGrid.value = grid;
}
//toggle b/w paging and virtualization
function toggleFeature(feature) {
if (feature === "paging") {
enablePaging.value = true;
view.value.pageSize = 100;
view.value.virtualization = false;
} else {
enablePaging.value = false;
view.value.pageSize = 0;
view.value.virtualization = true;
}
}
// show gif loader while data loading
function toggleSpinner(grid, show) {
let _rect = grid.controlRect;
let elem = grid.hostElement.querySelector(".spinner");
if (!elem) elem = wijmo.createElement(`<div class='spinner' style="left:${_rect.left}px;top:${_rect.top}px;width:${_rect.width}px;height:${_rect.height}px;"><img src="resources/Rounded%20blocks.gif"></div>`, grid.hostElement);
elem.style.display = show ? "block" : "none";
}
</script>
<style>
body {
margin-bottom: 36pt;
margin-top: 10px;
}
label {
padding-right: 10px;
}
.wj-flexgrid {
height: 400px;
}
.spinner {
position: absolute;
z-index: 10;
opacity: .5;
}
.spinner img {
margin: auto;
position: relative;
top: 40%;
left: 45%;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView RestAPI</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
return new (P || (P = Promise))(function (resolve, reject) {
function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
step((generator = generator.apply(thisArg, _arguments || [])).next());
});
};
import { RestCollectionView } from '@mescius/wijmo.rest';
import { DataType, isDate, DateTime, asNumber, isBoolean, httpRequest, copy, changeType, isString } from '@mescius/wijmo';
const _apiUrl = "https://demodata.mescius.io/wwi/api/v1/";
/**
* Class that extends {@link RestCollectionView} to support RestAPI data sources.
*/
export class RestCollectionViewExt extends RestCollectionView {
/**
* Initializes a new instance of the {@link RestCollectionViewExt} class.
*
* @param tableName Name of the table (entity) to retrieve from the service.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link RestCollectionView}.
*/
constructor(tableName, options) {
super();
this._url = _apiUrl;
this._tbl = tableName;
copy(this, options);
}
// parse json data
_jsonReviver(key, value) {
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// get parameter for sorting, filtering, paging and virtualization
_getReadParams() {
let settings = {};
// apply filter
if (this.filterOnServer && this._filterProvider) {
let filter = this._asODataFilter(this._filterProvider);
if (filter.length > 0) {
settings.filterBy = filter;
}
}
//apply sortBy
if (this.sortOnServer && this.sortDescriptions.length > 0) {
let _sortBy = [];
for (let i = 0; i < this.sortDescriptions.length; i++) {
let sort = `${this.sortDescriptions[i].property} ${this.sortDescriptions[i].ascending ? 'ASC' : 'DESC'}`;
_sortBy.push(sort); // add sort
}
settings.sortBy = _sortBy.join(',');
}
// current view window
if (this.virtualization) {
settings.skip = this._start;
settings.top = this._fetchSize();
}
// get page params
if (this.pageOnServer && this.pageSize > 0) {
settings.skip = this.pageIndex * this.pageSize;
settings.top = this.pageSize;
}
if (this.fields && this.fields.length > 0) {
settings.select = this.fields;
}
return settings;
}
// ** overrides
getItems() {
// cancel any pending requests
if (this._pendingReq) {
this._pendingReq.abort();
}
return new Promise(resolve => {
let _settings = this._getReadParams(); // get the items virtually
this._pendingReq = httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.items);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => { this._pendingReq = null; } // no pending requests
});
});
;
}
//#region Filter Implementation
// gets the OData filter definition from a wijmo.grid.filter.FlexGridFilter object.
// https://www.odata.org/documentation/odata-version-2-0/uri-conventions/
_asODataFilter(filter) {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c], cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
}
else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf) {
let col = vf.column, fld = col.binding, map = col.dataMap, def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, DataType.String, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def)
def += ' or ';
def += this._asEquals(fld, value, DataType.String);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld, value, type) {
let def = '', DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
}
else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
}
else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf) {
let c1 = this._asODataCondition(cf, cf.condition1), c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2)
return '((' + c1 + (cf.and ? ') and (' : ') or (') + c2 + '))';
if (c1)
return '(' + c1 + ')';
if (c2)
return '(' + c2 + ')';
return null;
}
_asODataCondition(cf, cnd) {
let col = cf.column, fld = col.binding, map = col.dataMap, value = changeType(cnd.value, DataType.String, col.format);
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, DataType.String);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return `${fld} starts-with ${value}`;
case 7: // EW = 7,
return `${fld} ends-with ${value}`;
case 8: // CT = 8,
return `${fld} contains ${value}`;
case 9: // NC = 9
return `${fld} not-contains ${value}`;
case 10: // NBW = 10
return `${fld} not-starts-with ${value}`;
case 11: // NEW = 11
return `${fld} not-ends-with ${value}`;
}
}
_asODataValue(value, dataType) {
if (isDate(value)) {
value = `'${value.toJSON()}'`;
return value;
}
else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
}
else if (isBoolean(value)) {
return "'" + value + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, enableProdMode, ChangeDetectorRef, ɵresolveComponentResources, ViewChild } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { WjGridFilterModule } from '@mescius/wijmo.angular2.grid.filter';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { RestCollectionViewExt } from './rest-collection-view-ext';
import { FlexGrid } from '@mescius/wijmo.grid';
import { createElement } from '@mescius/wijmo';
// field info for PurchaseOrders table
const fields = 'OrderId,StockItem,Color,State,City,Quantity,UnitPrice,Date,IsChillerStock'.split(',');
//
@Component({
standalone: true,
imports: [WjGridModule, WjGridFilterModule, WjInputModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
enablePaging = true;
pageSize = 100;
isReadOnly = true;
//create RestCollectionViewExt instance
view = new RestCollectionViewExt('purchaseorders', {
fields: fields,
pageSize: this.pageSize,
loading: () => {
this.toggleSpinner(this._flexGrid, true);
},
loaded: () => {
this.toggleSpinner(this._flexGrid, false);
},
});
@ViewChild('theGrid', { static: true }) private _flexGrid: FlexGrid;
constructor(private readonly _chDetector: ChangeDetectorRef) {}
//toggle b/w paging and virtualization
toggleFeature(feature: string) {
let view = this.view;
if (feature == 'paging') {
this.enablePaging = true;
view.pageSize = this.pageSize;
view.virtualization = false;
} else {
this.enablePaging = false;
view.pageSize = 0;
view.virtualization = true;
}
}
//show gif loader while data loading
toggleSpinner(grid: FlexGrid, show: boolean) {
let _rect = grid.controlRect;
let elem: HTMLElement = grid.hostElement.querySelector('.spinner');
if (!elem)
elem = createElement(
`<div class='spinner' style="left:${_rect.left}px;top:${_rect.top}px;width:${_rect.width}px;height:${_rect.height}px;"><img src="resources/Rounded%20blocks.gif"></div>`,
grid.hostElement,
);
elem.style.display = show ? 'block' : 'none';
}
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView RestAPI</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<label>
<input id="paging"
type="radio"
name="viewtype"
value="paging"
checked
(change)="toggleFeature('paging')">Paging
</label>
<label>
<input id="virtualization"
type="radio"
name="viewtype"
value="virtualization"
(change)="toggleFeature('virtualization')">Virtualization
</label>
<br />
<div *ngIf="enablePaging">
<wj-collection-view-navigator #nav
[cv]="view"
[byPage]="true">
</wj-collection-view-navigator>
</div>
<wj-flex-grid #theGrid
[isReadOnly]="isReadOnly"
[itemsSource]="view">
<wj-flex-grid-filter></wj-flex-grid-filter>
</wj-flex-grid>
</div>
body {
margin-bottom: 36pt;
margin-top:10px;
}
label{
padding-right: 10px;
}
.wj-flexgrid {
height: 400px;
}
.spinner{
position: absolute;
z-index: 10;
opacity: .5;
}
.spinner img {
margin: auto;
position: relative;
top:40%;
left:45%;
}
import { RestCollectionView } from '@mescius/wijmo.rest';
import {
DataType, isDate, DateTime, asNumber, isBoolean, httpRequest, copy, changeType, isString
} from '@mescius/wijmo';
const _apiUrl = "https://demodata.mescius.io/wwi/api/v1/";
/**
* Class that extends {@link RestCollectionView} to support RestAPI data sources.
*/
export class RestCollectionViewExt extends RestCollectionView {
_pendingRequest: XMLHttpRequest;
_url: string = _apiUrl;
_tbl: string;
/**
* Initializes a new instance of the {@link RestCollectionViewExt} class.
*
* @param tableName Name of the table (entity) to retrieve from the service.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link RestCollectionView}.
*/
constructor(tableName: string, options?: any) {
super();
this._tbl = tableName;
copy(this, options);
}
// parse json data
protected _jsonReviver(key: string, value: any): any {
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// get parameter for sorting, filtering, paging and virtualization
_getReadParams(): any {
let settings: any = {};
// apply filter
if (this.filterOnServer && this._filterProvider) {
let filter = this._asODataFilter(this._filterProvider);
if (filter.length > 0) {
settings.filterBy = filter;
}
}
//apply sortBy
if (this.sortOnServer && this.sortDescriptions.length > 0) {
let _sortBy = [];
for (let i = 0; i < this.sortDescriptions.length; i++) {
let sort = `${this.sortDescriptions[i].property} ${this.sortDescriptions[i].ascending ? 'ASC' : 'DESC'}`;
_sortBy.push(sort);// add sort
}
settings.sortBy = _sortBy.join(',');
}
// current view window
if (this.virtualization) {
settings.skip = this._start;
settings.top = this._fetchSize();
}
// get page params
if (this.pageOnServer && this.pageSize > 0) {
settings.skip = this.pageIndex * this.pageSize
settings.top = this.pageSize;
}
if (this.fields && this.fields.length > 0) {
settings.select = this.fields;
}
return settings;
}
// ** overrides
protected getItems(): Promise<any[]> {
// cancel any pending requests
if (this._pendingReq) {
this._pendingReq.abort();
}
return new Promise<any>(resolve => {
let _settings = this._getReadParams(); // get the items virtually
this._pendingReq = httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: async xhr => {
// parse response
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.items);
},
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => { this._pendingReq = null; }// no pending requests
});
});;
}
//#region Filter Implementation
// gets the OData filter definition from a wijmo.grid.filter.FlexGridFilter object.
// https://www.odata.org/documentation/odata-version-2-0/uri-conventions/
_asODataFilter(filter: any): string {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c],
cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
} else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf: any): string {
let col = vf.column,
fld = col.binding,
map = col.dataMap,
def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, DataType.String, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def) def += ' or ';
def += this._asEquals(fld, value, DataType.String);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld: string, value: any, type: DataType): string {
let def = '',
DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
} else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
} else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf: any): string {
let c1 = this._asODataCondition(cf, cf.condition1),
c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2) return '((' + c1 + (cf.and ? ') and (' : ') or (') + c2 + '))';
if (c1) return '(' + c1 + ')';
if (c2) return '(' + c2 + ')';
return null;
}
_asODataCondition(cf: any, cnd: any): string {
let col = cf.column,
fld = col.binding,
map = col.dataMap,
value = changeType(cnd.value, DataType.String, col.format);
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, DataType.String);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return `${fld} starts-with ${value}`;
case 7: // EW = 7,
return `${fld} ends-with ${value}`;
case 8: // CT = 8,
return `${fld} contains ${value}`;
case 9: // NC = 9
return `${fld} not-contains ${value}`;
case 10: // NBW = 10
return `${fld} not-starts-with ${value}`;
case 11: // NEW = 11
return `${fld} not-ends-with ${value}`;
}
}
_asODataValue(value: any, dataType: DataType): string {
if (isDate(value)) {
value = `'${value.toJSON()}'`;
return value;
} else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
} else if (isBoolean(value)) {
return "'" + value + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
//#endRegion
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import { CollectionViewNavigator } from '@mescius/wijmo.react.input';
import { FlexGrid } from '@mescius/wijmo.react.grid';
import { FlexGridFilter } from '@mescius/wijmo.react.grid.filter';
import { RestCollectionViewExt } from "./rest-collection-view-ext";
import { createElement } from '@mescius/wijmo';
import './app.css';
// field info for PurchaseOrders table
const fields = 'OrderId,StockItem,Color,State,City,Quantity,UnitPrice,Date,IsChillerStock'.split(',');
function App() {
//collectionView settings
const settings = {
fields: fields,
pageSize: 100,
virtualization: false,
loading: () => { toggleSpinner(gridRef.current.control, true); },
loaded: () => { toggleSpinner(gridRef.current.control, false); }
};
const [enablePaging, setEnablePaging] = useState(true);
const [isReadOnly] = useState(true);
//create RestCollectionViewExt instance
const [view] = useState(new RestCollectionViewExt('purchaseorders', settings));
const gridRef = useRef(null);
const navRef = useRef(null);
//toggle b/w paging and virtualization
const toggleFeature = (feature) => {
if (feature === 'paging') {
setEnablePaging(true);
view.pageSize = 100;
view.virtualization = false;
}
else {
setEnablePaging(false);
view.pageSize = 0;
view.virtualization = true;
}
};
return (<div className="container-fluid">
<label>
<input id="paging" type="radio" name="viewtype" value="paging" checked={enablePaging} onChange={() => toggleFeature('paging')}/>Paging
</label>
<label>
<input id="virtualization" type="radio" name="viewtype" value="virtualization" checked={!enablePaging} onChange={() => toggleFeature('virtualization')}/>Virtualization
</label>
<br />
{enablePaging && (<CollectionViewNavigator ref={navRef} cv={view} byPage={true}/>)}
<FlexGrid ref={gridRef} isReadOnly={isReadOnly} itemsSource={view}>
<FlexGridFilter />
</FlexGrid>
</div>);
}
//show gif loader while data loading
function toggleSpinner(grid, show) {
let _rect = grid.controlRect;
let elem = grid.hostElement.querySelector('.spinner');
if (!elem)
elem = createElement(`<div class='spinner' style="left:${_rect.left}px;top:${_rect.top}px;width:${_rect.width}px;height:${_rect.height}px;"><img src="resources/Rounded%20blocks.gif"></div>`, grid.hostElement);
elem.style.display = show ? 'block' : 'none';
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo RestCollectionView RestAPI</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
body {
margin-bottom: 36pt;
margin-top: 10px;
}
label {
padding-right: 10px;
}
.wj-flexgrid {
height: 400px;
}
.spinner {
position: absolute;
z-index: 10;
opacity: .5;
}
.spinner img {
margin: auto;
position: relative;
top: 40%;
left: 45%;
}
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
return new (P || (P = Promise))(function (resolve, reject) {
function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
step((generator = generator.apply(thisArg, _arguments || [])).next());
});
};
import { RestCollectionView } from '@mescius/wijmo.rest';
import { DataType, isDate, DateTime, asNumber, isBoolean, httpRequest, copy, changeType, isString } from '@mescius/wijmo';
const _apiUrl = "https://demodata.mescius.io/wwi/api/v1/";
/**
* Class that extends {@link RestCollectionView} to support RestAPI data sources.
*/
export class RestCollectionViewExt extends RestCollectionView {
/**
* Initializes a new instance of the {@link RestCollectionViewExt} class.
*
* @param tableName Name of the table (entity) to retrieve from the service.
* @param options JavaScript object containing initialization data (property
* values and event handlers) for the {@link RestCollectionView}.
*/
constructor(tableName, options) {
super();
this._url = _apiUrl;
this._tbl = tableName;
copy(this, options);
}
// parse json data
_jsonReviver(key, value) {
const _rxDate = /^\d{4}\-\d{2}\-\d{2}T\d{2}\:\d{2}\:\d{2}|\/Date\([\d\-]*?\)/;
if (typeof value === 'string' && _rxDate.test(value)) {
value = value.indexOf('/Date(') == 0 // verbosejson
? new Date(parseInt(value.substr(6)))
: new Date(value);
}
return value;
}
// get parameter for sorting, filtering, paging and virtualization
_getReadParams() {
let settings = {};
// apply filter
if (this.filterOnServer && this._filterProvider) {
let filter = this._asODataFilter(this._filterProvider);
if (filter.length > 0) {
settings.filterBy = filter;
}
}
//apply sortBy
if (this.sortOnServer && this.sortDescriptions.length > 0) {
let _sortBy = [];
for (let i = 0; i < this.sortDescriptions.length; i++) {
let sort = `${this.sortDescriptions[i].property} ${this.sortDescriptions[i].ascending ? 'ASC' : 'DESC'}`;
_sortBy.push(sort); // add sort
}
settings.sortBy = _sortBy.join(',');
}
// current view window
if (this.virtualization) {
settings.skip = this._start;
settings.top = this._fetchSize();
}
// get page params
if (this.pageOnServer && this.pageSize > 0) {
settings.skip = this.pageIndex * this.pageSize;
settings.top = this.pageSize;
}
if (this.fields && this.fields.length > 0) {
settings.select = this.fields;
}
return settings;
}
// ** overrides
getItems() {
// cancel any pending requests
if (this._pendingReq) {
this._pendingReq.abort();
}
return new Promise(resolve => {
let _settings = this._getReadParams(); // get the items virtually
this._pendingReq = httpRequest(this._url + this._tbl, {
requestHeaders: this.requestHeaders,
data: _settings,
success: (xhr) => __awaiter(this, void 0, void 0, function* () {
// parse response
let resp = JSON.parse(xhr.responseText, this._jsonReviver);
let _count = asNumber(resp.totalItemCount);
if (_count != this._totalItemCount)
this._totalItemCount = _count;
resolve(resp.items);
}),
error: xhr => this._raiseError(xhr.responseText, false),
complete: xhr => { this._pendingReq = null; } // no pending requests
});
});
;
}
//#region Filter Implementation
// gets the OData filter definition from a wijmo.grid.filter.FlexGridFilter object.
// https://www.odata.org/documentation/odata-version-2-0/uri-conventions/
_asODataFilter(filter) {
let def = '';
for (let c = 0; c < filter.grid.columns.length; c++) {
let col = filter.grid.columns[c], cf = filter.getColumnFilter(col, false);
if (cf && cf.isActive) {
if (def) {
def += ' and ';
}
if (cf.conditionFilter && cf.conditionFilter.isActive) {
def += this._asODataConditionFilter(cf.conditionFilter);
}
else if (cf.valueFilter && cf.valueFilter.isActive) {
def += this._asODataValueFilter(cf.valueFilter);
}
}
}
return def;
}
_asODataValueFilter(vf) {
let col = vf.column, fld = col.binding, map = col.dataMap, def = '';
// build condition with 'eq/or'
for (let key in vf.showValues) {
let value = changeType(key, DataType.String, col.format);
if (map && isString(value)) { // TFS 239356
value = map.getKeyValue(value);
}
if (def)
def += ' or ';
def += this._asEquals(fld, value, DataType.String);
}
// enclose in parenthesis if not empty
if (def.length) {
def = '(' + def + ')';
}
// all done
return def;
}
_asEquals(fld, value, type) {
let def = '', DT = DataType;
if (value === '' || value == null) { // null or empty
def += fld + ' eq null';
if (type == DT.String) { // empty OK for strings only
def += ' or ' + fld + ' eq \'\'';
}
}
else if (type == DT.Date) { // non-null/empty dates (TFS 458080)
def += fld + ' ge ' + this._asODataValue(value, type) + ' and ' +
fld + ' lt ' + this._asODataValue(DateTime.addDays(value, 1), type);
}
else { // other types
def += fld + ' eq ' + this._asODataValue(value, type);
}
return '(' + def + ')';
}
_asODataConditionFilter(cf) {
let c1 = this._asODataCondition(cf, cf.condition1), c2 = this._asODataCondition(cf, cf.condition2);
if (c1 && c2)
return '((' + c1 + (cf.and ? ') and (' : ') or (') + c2 + '))';
if (c1)
return '(' + c1 + ')';
if (c2)
return '(' + c2 + ')';
return null;
}
_asODataCondition(cf, cnd) {
let col = cf.column, fld = col.binding, map = col.dataMap, value = changeType(cnd.value, DataType.String, col.format);
if (map && isString(value)) { // TFS 440901
value = map.getKeyValue(value);
}
value = this._asODataValue(value, DataType.String);
switch (cnd.operator) {
case 0: // EQ = 0,
return fld + ' eq ' + value;
case 1: // NE = 1,
return fld + ' ne ' + value;
case 2: // GT = 2,
return fld + ' gt ' + value;
case 3: // GE = 3,
return fld + ' ge ' + value;
case 4: // LT = 4,
return fld + ' lt ' + value;
case 5: // LE = 5,
return fld + ' le ' + value;
case 6: // BW = 6,
return `${fld} starts-with ${value}`;
case 7: // EW = 7,
return `${fld} ends-with ${value}`;
case 8: // CT = 8,
return `${fld} contains ${value}`;
case 9: // NC = 9
return `${fld} not-contains ${value}`;
case 10: // NBW = 10
return `${fld} not-starts-with ${value}`;
case 11: // NEW = 11
return `${fld} not-ends-with ${value}`;
}
}
_asODataValue(value, dataType) {
if (isDate(value)) {
value = `'${value.toJSON()}'`;
return value;
}
else if (isString(value)) {
return "'" + value.replace(/'/g, "''") + "'";
}
else if (isBoolean(value)) {
return "'" + value + "'";
}
else if (value != null) {
return value.toString();
}
return dataType == DataType.String ? "''" : null;
}
}
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);